import java.util.Scanner;

public class Bowling_DA {

	class Point {
		double x, y;

		Point(double x, double y) {
			this.x = x;
			this.y = y;
		}
	}

	private static final double W = 85.0;
	private static final double EPS = 1e-9;
	private static final double R = 16.0;

	private void work() {
		Point p1 = new Point(0, 0);
		Scanner sc = new Scanner(System.in);
		int nc = sc.nextInt();
		while (nc-- > 0) {
			double T = 100 * sc.nextDouble();
			double th = 0.5 * Math.PI - Math.toRadians(sc.nextDouble());
			double x = T / Math.tan(th);
			Point p2 = new Point(x, T);
			Point p3 = new Point(0, T);
			System.out.println(linear(p1, p2, p3));
		}
	}

	private String linear(Point p1, Point p2, Point p3) {
		double min = Double.POSITIVE_INFINITY;
		int cnt = 0;
		while (true) {
			double d = pointToLineDistance(p1, p2, p3);
			if (d > min)
				break;
			min = d;
			p3.x += W;
			cnt++;
		}
		return min <= R + EPS ? "yes" : "no";
	}

	// blah, can't code this or something
	private String ternary(Point p1, double T, double x, Point p2) {
		int lo = 0;
		int hi = 10 + (int) (Math.ceil((x + 0.5 * W) / W));
		for (int i = 0; i < 200; i++) {
			int a = (2 * lo + hi) / 3;
			int b = (lo + 2 * hi) / 3;
			double da = pointToLineDistance(p1, p2, new Point(a * W, T));
			double db = pointToLineDistance(p1, p2, new Point(b * W, T));
			if (da > db)
				lo = b;
			else
				hi = a;
		}
		System.err.printf("lo=%d hi=%d\n", lo, hi);
		double d = pointToLineDistance(p1, p2, new Point(lo * W, T));
		System.err.println("dist ternary = " + d);
		return d <= R + EPS ? "yes" : "no";
	}

	private double pointToLineDistance(Point p1, Point p2, Point p3) {
		double u = ((p3.x - p1.x) * (p2.x - p1.x) + (p3.y - p1.y)
				* (p2.y - p1.y))
				/ distSq(p1, p2);
		double x = p1.x + u * (p2.x - p1.x);
		double y = p1.y + u * (p2.y - p1.y);
		return dist(p3, new Point(x, y));
	}

	private double distSq(Point p1, Point p2) {
		double dx = p1.x - p2.x;
		double dy = p1.y - p2.y;
		return dx * dx + dy * dy;
	}

	private double dist(Point p1, Point p2) {
		return Math.sqrt(distSq(p1, p2));
	}

	public static void main(String[] args) {
		new Bowling_DA().work();
	}

}
