import java.util.Scanner;

public class Ripple_DA {

	private static final int[] DR = { -1, 0, 1, 0 };
	private static final int[] DC = { 0, 1, 0, -1 };

	private int m, n, mask, count;
	private int[][] g, deg, graph[];

	private void work() {
		Scanner sc = new Scanner(System.in);
		int nc = sc.nextInt();
		while (nc-- > 0) {
			m = sc.nextInt();
			n = sc.nextInt();
			g = new int[m][n];
			for (int i = 0; i < m; i++) {
				char[] line = sc.next().toCharArray();
				for (int j = 0; j < n; j++) {
					g[i][j] = line[j] - '0';
				}
			}
			graph = new int[m][n][4];
			deg = new int[m][n];
			for (int i = 0; i < m; i++) {
				for (int j = 0; j < n; j++) {
					int t = sc.nextInt();
					for (int k = 0; k < 4; k++) {
						if (((1 << k) & t) != 0)
							graph[i][j][deg[i][j]++] = k;
					}
				}
			}

			boolean ok = true;
			for (int i = 0; i < m && ok; i++) {
				for (int j = 0; j < n && ok; j++) {
					for (int ii = Math.max(0, i - g[i][j]); ii <= Math.min(
							m - 1, i + g[i][j]); ii++) {
						if (i == ii)
							continue;
						if (g[i][j] == g[ii][j]) {
							ok = false;
							break;
						}
					}
					for (int jj = Math.max(0, j - g[i][j]); jj <= Math.min(
							n - 1, j + g[i][j]); jj++) {
						if (j == jj)
							continue;
						if (g[i][j] == g[i][jj]) {
							ok = false;
							break;
						}
					}
				}
			}

			if (ok) {
				for (int i = 0; i < m && ok; i++) {
					for (int j = 0; j < n; j++) {
						if (g[i][j] > 0) {
							mask = 1 << (g[i][j] - 1);
							count = 1;
							g[i][j] = 0;
							go(i, j);
							if (mask + 1 != 1 << count) {
								ok = false;
								break;
							}
						}
					}
				}
			}

			System.out.println(ok ? "valid" : "invalid");
		}
	}

	private void go(int r, int c) {
		for (int i = 0; i < deg[r][c]; i++) {
			int dir = graph[r][c][i];
			int nr = r + DR[dir];
			int nc = c + DC[dir];
			if (g[nr][nc] > 0) {
				mask |= 1 << (g[nr][nc] - 1);
				count++;
				g[nr][nc] = 0;
				go(nr, nc);
			}
		}
	}

	public static void main(String[] args) {
		new Ripple_DA().work();
	}

}
