import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class Shift_DA {
	class MP {

		public MP(int[] t, int[] p) {
			T = t;
			P = p;
			tlen = T.length;
			plen = P.length;
			mpNext = new int[plen + 1];
		}

		private int[] T, P;
		private int tlen, plen;
		private int[] mpNext;
		private List<Integer> matches;

		private void preMp() {
			int i = 0;
			int j = mpNext[0] = -1;
			while (i < plen) {
				while (j > -1 && P[i] != P[j]) {
					j = mpNext[j];
				}
				mpNext[++i] = ++j;
			}
		}

		private void mp() {
			preMp();
			int i = 0, j = 0;
			while (j < tlen) {
				while (i > -1 && P[i] != T[j]) {
					i = mpNext[i];
				}
				i++;
				j++;
				if (i >= plen) {
					matches.add(j - i);
					i = mpNext[i];
				}
			}

		}

		public List<Integer> getMatches() {
			matches = new ArrayList<Integer>();
			mp();
			return matches;
		}

	}

	private void work() {

		Scanner sc = new Scanner(new BufferedReader(new InputStreamReader(
				System.in)));
		int nc = sc.nextInt();
		while (nc-- > 0) {
			String alphabet = sc.next();
			int asz = alphabet.length();
			char[] word = sc.next().toCharArray();
			char[] text = sc.next().toCharArray();

			if (asz < 3 || asz > 62 || word.length > 50000
					|| text.length > 500000)
				throw new RuntimeException(String.format(
						"asz=%d w.len=%d t.len=%d", asz, word.length,
						text.length));
			// System.err.println(String.format("asz=%d w.len=%d t.len=%d", asz,
			// word.length, text.length));

			List<Integer> res = fast(alphabet, asz, word, text);
			// List<Integer> res = slow(alphabet, asz, word, text);

			if (res.isEmpty()) {
				System.out.println("no solution");
			} else if (res.size() == 1) {
				System.out.println("unique: " + res.get(0));
			} else {
				System.out.print("ambiguous:");
				Collections.sort(res);
				for (int i : res)
					System.out.print(" " + i);
				System.out.println();
			}
		}
	}

	private void shift(char[] s, String a) {
		for (int i = 0; i < s.length; i++) {
			s[i] = a.charAt((a.indexOf(s[i]) + 1) % a.length());
		}
	}

	private List<Integer> slow(String alphabet, int asz, char[] word,
			char[] text) {
		List<Integer> res = new ArrayList<Integer>();
		String t = new String(text);
		for (int i = 0; i < asz; i++) {
			String w = new String(word);
			int k = t.indexOf(w);
			if (k >= 0 && k == t.lastIndexOf(w))
				res.add(i);
			shift(word, alphabet);
		}
		return res;
	}

	private List<Integer> fast(String alphabet, int asz, char[] word,
			char[] text) {
		int[] fq = new int[asz];

		if (word.length == 1) {
			for (int i = 0; i < text.length; i++) {
				fq[alphabet.indexOf(text[i])]++;
			}
		} else {
			int[] p = getDiff(asz, alphabet, word);
			int[] t = getDiff(asz, alphabet, text);
			MP mp = new MP(t, p);
			List<Integer> matches = mp.getMatches();
			for (int pos : matches) {
				fq[alphabet.indexOf(text[pos])]++;
			}
		}

		List<Integer> res = new ArrayList<Integer>();
		for (int i = 0; i < asz; i++) {
			if (fq[i] == 1) {
				int d = i - alphabet.indexOf(word[0]);
				if (d < 0)
					d += asz;
				res.add(d);
			}
		}
		return res;
	}

	private int[] getDiff(int asz, String alphabet, char[] s) {
		int[] diff = new int[s.length - 1];
		for (int i = 0; i < diff.length; i++) {
			diff[i] = alphabet.indexOf(s[i + 1]) - alphabet.indexOf(s[i]);
			if (diff[i] < 0)
				diff[i] += asz;
		}
		return diff;
	}

	public static void main(String[] args) {
		new Shift_DA().work();
	}

}
